form_data_parse() LANG=C busybox awk \
	-vRS='\r\n' -vvars='(file)?name="[^"]+"' \
	-vdumpvar='%s="%s";' -vkey='name="' '
	# -- is appended to the boundary at the last entry
	# so we have 2 cases
	# RS$(0)RS     # split
	# RS$(0)"--"RS # EOF
	function name_from(s) {
		value = substr(s, length(key)  + match($0,key))
		value = substr(value, 0, index(value,"\"") -1 )
		return value
	}
	BEGIN {
		getline
		RS=RS$(0)"(--)?"RS }
	{
	 	id= NR-1
		system("mkdir "id)
		# the first empty line is the separator between header
		# and data
		sep = index($0,"\r\n\r\n")
		header = name = substr($0,0,sep)
		printf "%s", header > id"/header"
		print "id="id > id"/vars"
		for ( ; match( header ,vars) ;
			header = substr( header, RSTART + RLENGTH ) ) {
			printf "%s;", substr( header, RSTART, RLENGTH) > id"/vars"
		}
		name = name_from(name)
		serve[name] = serve[name]" "id
	  	gsub("\r\n","\n"id"\t",header)
		printf "%s", substr($0,sep + 4 ) > id"/data"
	}
	END { split(accept,yes,"[ ,]+")
		for ( y in yes ) {
			y=yes[y]
			printf dumpvar, y , substr(serve[y],2) }
	}
' "$@"


HTTP_OK() <<-% _http_header
printf 'HTTP/1.1 200 OK
Content-Type: text/html; charset=UTF-8

%

_xml_decl() {
	local fn tag ns
	for fn; do
		tag=${ns+$ns:}${fn#*=} fn=${fn%=*}
		case "${tag}"
		in (*/) eval ${fn%/}'() echo -n "<'${tag%/}'${1:+ $*}/>"'
		;; (:*) ns=${tag#:}
		;; (*)  eval $fn'() {
			echo -n "<'$tag'${1:+ $*}>"
			trap '\''echo -n "</'$tag'>"'\''  EXIT
			}'
		esac
	done
}

css() printf '<link rel="stylesheet" href="%s"/>' "$@"

html() {
	echo -n "<!DOCTYPE html><html${1:+ $*}>"
	trap 'echo -n '\''</html>'\' EXIT
}
_() echo -n "<![CDATA[$*]]>"
_() echo -n "$*"

_xml_decl head title meta/ body \
	menu nav section header footer \
	h1 h2 h3 h4 h5 h6 h7 h8 h9 \
	div p a script hr/ \
	table tbody tr td \
	ul ol li dl dt dd \
	pre code \
	form fieldset legend input/ label \
	:svg svg circle


radio     () input type='"radio"' "$@"
upload    () input type='"file"' "$@"
lbl () {
	local for="$1" desc="$2"; shift 2
	(label for="\"$for\"" "$@" ;_ "$desc")
}
email    () {
	local id="$1"; shift
	input "name=\"$id\" id=\"$id\"" type='"email"' "$@"
}
upload    () {
	local id="$1"; shift
	input "name=\"$id\" id=\"$id\"" type='"file"' "$@"
}
submit    () {
	local value="$1"; shift
	input value="\"$value\"" type='"submit"' "$@"
}
form_data () form method='"post"' enctype='"multipart/form-data"' "$@"

lis() printf '<li><a href="%s">%s</a></li>' "$@"
A() (it="$1" lbl="$2" ; shift 2; a "href=\"$it\"${1+$*}" ;_ "$lbl" )

alias '[%=<<-%] lowdown'
_http_header() sed 's/$/\r/' "$@"

# # CDATA
# # <![CDATA[
# # ]]>
